# -*- coding: utf-8 -*-
"""
Created on Sat Sep 19 23:27:11 2020

@author: subrata
"""


from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd


Y1=np.loadtxt('data_ML_sir_1000.txt',float)
trainlength=20000
testlength=5000
initlength=0

insize=950
outsize=50
resize = 1000
a = 0.5

Win = (random.rand(resize,1+insize)-0.5)*1
W= (random.rand(resize,resize)-0.5)*1

indata=Y1[:,0:insize]
outdata=Y1[:,insize:outsize+insize]

X= zeros((1+insize+resize,trainlength-initlength))
Yt= outdata[initlength:trainlength,:]
x= zeros((resize,1))
for t in range(trainlength):
    u =indata[t,:]
    u = np.reshape(u,(insize,1))
    x = (1-a)*x +a*tanh(dot(Win,vstack((1,u)) ) + dot(W,x))
    if t > initlength:
        X[:,t-initlength] = vstack((1,u,x))[:,0]
        
reg= 1e-10
X_T = X.T
Wout = dot(dot(Yt.T,X_T),linalg.inv(dot(X,X_T)+reg*eye(1+insize+resize)))

Y =zeros((outsize,testlength))  
u = indata[trainlength,:] 
u = np.reshape(u,(insize,1)) 
for t in range(testlength):
    x = (1-a)*x + a*tanh( dot( Win, vstack((1,u)) ) + dot( W, x ) )
    y = dot( Wout, vstack((1,u,x)) )
    Y[:,t] = y.T
    u = indata[trainlength+t+1,:] 
    u = np.reshape(u,(insize,1))    

ind=(0,20000,25000)
ind1=(0,0.1,0.2)
pl.figure(0)
pl.plot(Y1[0:25000,10],color='r',linewidth=10)
pl.axvline(x = 20000,linewidth = 3, linestyle ="--", color ='black')
pl.yticks(fontsize=0)
pl.xticks(ind,('',r'$t_{t}$',r'$t_{f}$'),fontsize=60)
pl.xlabel(r'$t$',fontsize=60)
pl.ylabel(r'$\mathcal{I}$',fontsize=60)
pl.rcParams['axes.linewidth']=4
pl.tick_params(direction= 'out', length=0,width=0)
#pl.arrow(0,0,25000,0.,color='black' ,length_includes_head=True,head_width=.01,head_length=.01)
pl.tight_layout()

pl.figure(1)
pl.plot(Y1[0:25000,201],color='r',linewidth=10)
pl.axvline(x = 20000,linewidth = 3, linestyle ="--", color ='black')
pl.yticks(fontsize=0)
pl.xticks(ind,('',r'$t_{r}$',r'$t_{f}$'),fontsize=60)
pl.xlabel(r'$t$',fontsize=60)
pl.ylabel(r'$\mathcal{I}$',fontsize=60)
#pl.annotate("",xy=(25000,0),xytext=(0.3,0), arrowprops=dict(arrowstyle="->"))
pl.tight_layout()

pl.figure(2)
pl.plot(Y1[0:25000,600],color='r',linewidth=10)
pl.axvline(x = 20000,linewidth = 3, linestyle ="--", color ='black')
pl.yticks(fontsize=0)
pl.xticks(ind,('',r'$t_{r}$',r'$t_{f}$'),fontsize=60)
pl.xlabel(r'$t$',fontsize=60)
pl.ylabel(r'$\mathcal{I}$',fontsize=60)
pl.tight_layout()

pl.figure(3)
pl.plot(Y1[0:25000,700],color='r',linewidth=10)
pl.axvline(x = 20000,linewidth = 3, linestyle ="--", color ='black')
pl.yticks(fontsize=0)
pl.xticks(ind,('',r'$t_{r}$',r'$t_{f}$'),fontsize=60)
pl.xlabel(r'$t$',fontsize=60)
pl.ylabel(r'$\mathcal{I}$',fontsize=60)
pl.tight_layout()


pl.figure(4)
pl.plot(Y1[0:25000,103],color='r',linewidth=10)
pl.axvline(x = 20000,linewidth = 3, linestyle ="--", color ='black')
pl.yticks(fontsize=0)
pl.xticks(ind,('',r'$t_{r}$',r'$t_{f}$'),fontsize=60)
pl.xlabel(r'$t$',fontsize=60)
pl.ylabel(r'$\mathcal{I}$',fontsize=60)
pl.tight_layout()


days = np.arange(0,25000)
for i in range(30,50):
    fig,ax = pl.subplots()
    ax.plot(days[0:25000],outdata[0:25000,i],'blue',lw=10)
    ax.scatter(days[20000:25000:700],Y[i,0:5000:700],s=400,color='none',edgecolors='darkorange',lw=5)
    pl.axvline(x = 20000,linewidth = 3, linestyle ="--", color ='black')
    pl.yticks(fontsize=0)
    pl.xticks(ind,('',r'$t_{r}$',r'$t_{f}$'),fontsize=60)
    pl.xlabel(r'$t$',fontsize=60)
    pl.ylabel(r'$\mathcal{I}$',fontsize=60)
    pl.tight_layout()
