# -*- coding: utf-8 -*-
"""
Created on Mon May 03 12:31:33 2021

@author: subrata
"""

from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd
from matplotlib.dates import DateFormatter
import matplotlib.ticker as ticker
from datetime import datetime
from scipy.optimize import curve_fit
import scipy.io
import scipy.linalg
from scipy.stats import gompertz
from scipy.signal import savgol_filter

a1=np.loadtxt('test_part_croatia.txt',float) 
a2=np.loadtxt('pred_part_croatia.txt',float) 
b1=np.loadtxt('test_part_finland.txt',float) 
b2=np.loadtxt('pred_part_finland.txt',float)
c1=np.loadtxt('test_part_germany.txt',float) 
c2=np.loadtxt('pred_part_germany.txt',float)
d1=np.loadtxt('test_part_israel.txt',float) 
d2=np.loadtxt('pred_part_israel.txt',float)
e1=np.loadtxt('test_part_italy.txt',float) 
e2=np.loadtxt('pred_part_italy.txt',float)
f1=np.loadtxt('test_part_raj.txt',float) 
f2=np.loadtxt('pred_part_raj.txt',float)
g1=np.loadtxt('test_part_telengana.txt',float) 
g2=np.loadtxt('pred_part_telengana.txt',float)
h1=np.loadtxt('test_part_tripura.txt',float) 
h2=np.loadtxt('pred_part_tripura.txt',float)
i1=np.loadtxt('test_part_up.txt',float) 
i2=np.loadtxt('pred_part_up.txt',float)
j1=np.loadtxt('test_part_wb.txt',float) 
j2=np.loadtxt('pred_part_wb.txt',float)

formatter = ticker.ScalarFormatter(useMathText=True)
formatter.set_scientific(True)
formatter.set_powerlimits((0,5))
l3=28
l2=49
ind=(0,l3,l2)
ind1=(0,1000,2000)
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),a1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),a1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),a2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),a2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
pl.text(0.1,0.1,'Croatia',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(ind1,('0','1','2'),fontsize=35)
pl.legend(frameon=False,loc='upper right',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig1
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),a1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),a1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),a2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),a2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.4,'Croatia',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper left',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig2
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),b1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),b1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),b2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),b2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.3,0.2,'Finland',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper left',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig3
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),c1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),c1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),c2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),c2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.4,'Germany',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper left',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig4
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),d1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),d1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),d2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),d2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.7,0.8,'Isreal',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='lower left',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig5
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),e1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),e1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),e2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),e2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.4,'Italy',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper left',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig6
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),f1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),f1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),f2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),f2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.2,0.1,'Rajasthan',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper left',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig7
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),g1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),g1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),g2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),g2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.1,'Telangana',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper right',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig8
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),h1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),h1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),h2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),h2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.1,'Tripura',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper right',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig9
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),i1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),i1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),i2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),i2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.01,0.1,'Uttar Pradesh',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper right',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
#fig10
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),j1[:,0],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),j1[:,1],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),j2[:,1],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),j2[:,0],'grey',marker='o')
ax.yaxis.set_major_formatter(formatter)
#pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.1,'West Bengal',transform=ax.transAxes,fontsize=30)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper left',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
 