# -*- coding: utf-8 -*-
"""
Created on Tue Mar 02 12:57:25 2021

@author: subrata
"""

from numpy import *
from matplotlib.pyplot import *
import numpy as np
import pylab as pl
import scipy.linalg
import scipy.io
import pandas as pd
from matplotlib.dates import DateFormatter
import matplotlib.ticker as ticker
from datetime import datetime
from scipy.optimize import curve_fit
import scipy.io
import scipy.linalg
from scipy.stats import gompertz
from scipy.signal import savgol_filter

df = pd.read_csv('covid19_gt_10000_except_BIU (1).csv')
cc = list(df.keys())
del cc[0]
del cc[0]
Y2 = df[cc].values

Y1=np.zeros([280,189],float)
for i in range(0,280):
    for j in range(0,189):
        Y1[i,j]=Y2[i,j]
Y4=np.zeros([280,189],float)
Y4[0,:]=Y1[0,:]
for i in range(0,189):
    for j in range(0,279):
        Y4[j+1,i]=np.abs(Y1[j,i]-Y1[j+1,i])
y_h=[]
for i in range(0,189):
    y_h.append([])
    y_h[i]=savgol_filter(Y4[:,i],51,3)
Y3=np.zeros([280,189],float)  
for  i in range(0,189):
    for j in range(0,280):
        Y3[j,i]=y_h[i][j]  

        
l1=230 
n1=188
N0=40*Y3[l1,n1]
def gompertz_model(x,a=1,K=100000):
    return a*K*np.exp(-np.log(K/N0)*np.exp(-a*x))*(np.log(K/N0)*np.exp(-a*x))
        
def fit_data_to_function(x,y,function,plot=True):
    params,_= curve_fit(function,x,y,[1,100000])
    pl.plot(x,y,"go")#,label="observation")
    y_fit=function(x, *params)
#    print(r2_score(y,y_fit))
    if plot:
        pl.plot(x,y_fit,'bo')#,label="Fitted")
        #pl.legend()
        pl.show()
    return params

  
y1= Y4[l1:258,n1]
y2= Y3[l1:258,n1]
x1=np.arange(len(y1))
#y1=data 
#y2=Y4[:,89]
#y3=Y4[:,100]
#y4=Y4[:,101]
#y5=Y4[:,77]
#x1=np.arange(0,len(y1))
l2=258-l1+21 
params1= fit_data_to_function(x1,y1,gompertz_model)
params2= fit_data_to_function(x1,y2,gompertz_model)
x2=np.arange(0,l2)
P=[params1[0]*params1[1]*np.exp(-np.log(params1[1]/N0)*np.exp(-params1[0]*x))*(np.log(params1[1]/N0)*np.exp(-params1[0]*x)) for x in x2]
Q=[params2[0]*params2[1]*np.exp(-np.log(params2[1]/N0)*np.exp(-params2[0]*x))*(np.log(params2[1]/N0)*np.exp(-params2[0]*x)) for x in x2]




a1=np.arange(0.01,1,.01)
pa=[]
for i in range(len(a1)):
    a=a1[i]
    par=fit_data_to_function(x1,y2,gompertz_model)
    pa.append(par)
l3=258-l1
x3=np.arange(l3,l2)
C1=[]
for j in range(0,len(a1)):
    Z1=[pa[j][0]*pa[j][1]*np.exp(-np.log(pa[j][1]/N0)*np.exp(-pa[j][0]*x))*(np.log(pa[j][1]/N0)*np.exp(-pa[j][0]*x)) for x in x3]
    C1.append(Z1)
C2=[]
for k1 in range(0,21):
    C2.append([])
    for k2 in range(0,len(C1)):
        C2[k1].append(C1[k2][k1])
C3=[]
for k3 in range(0,len(C2)):
    C3.append(np.std(C2[k3][:]))
        
DataOut_1 = np.column_stack((Y3[l1:258,n1],Q[0:l3]))
DataOut_2= np.column_stack((Y3[258:279,n1],Q[l3:l2])) 
#np.savetxt('test_part_wb.txt',DataOut_1) 
#np.savetxt('pred_part_wb.txt',DataOut_2)   
ind=(0,l3,l2)
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3,3),Y4[l1:258:3,n1],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3,3),P[0:l3:3],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2,3),P[l3:l2:3],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2,3),Y4[258:279:3,n1],'grey',marker='o')
ax.yaxis.offsetText.set_fontsize(25)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.01,0.4,cc[n1],transform=ax.transAxes,fontsize=25)
pl.errorbar(np.arange(l3,l2,3),P[l3:l2:3],yerr=C3[0:21:3],fmt='ro',ecolor='k',elinewidth=2,capsize=5)
#pl.xlabel(r'$t$',fontsize=45)
pl.ylabel(r'$\mathcal{I}$',fontsize=45)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('18 Aug',' 14 Sept','5 Oct'),fontsize=30)
pl.yticks(fontsize=30)
pl.legend(frameon=False,loc='upper left',)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=30)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()

fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),Y4[l1:258,n1],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),Q[0:l3],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),Q[l3:l2],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),Y4[258:279,n1],'grey',marker='o')
pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.1,cc[n1],transform=ax.transAxes,fontsize=30)
#pl.xlabel(r'$t$',fontsize=45)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper right',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()

formatter = ticker.ScalarFormatter(useMathText=True)
formatter.set_scientific(True)
formatter.set_powerlimits((0,3))
fig,ax = pl.subplots(figsize=(6,6))
ax.plot(np.arange(0,l3),Y4[l1:258,n1],'silver',marker='o',label="data")
ax.plot(np.arange(0,l3),Q[0:l3],'blue',marker='o',label="fitted curve")
ax.plot(np.arange(l3,l2),Q[l3:l2],'red',marker='o',label="predicted")
ax.plot(np.arange(l3,l2),Y4[258:279,n1],'grey',marker='o')
pl.errorbar(np.arange(l3,l2),Q[l3:l2],yerr=C3[0:21],fmt='ro',ecolor='k',elinewidth=7,capsize=5)
ax.yaxis.set_major_formatter(formatter)
ax.yaxis.offsetText.set_fontsize(35)
pl.axvline(x = l3,linewidth = 3, linestyle ="--", color ='black')
ax.text(0.1,0.1,cc[n1],transform=ax.transAxes,fontsize=30)
#pl.xlabel(r'$t$',fontsize=45)
pl.ylabel(r'$\mathcal{I}$',fontsize=40)
pl.ticklabel_format(axis="y",style="sci",scilimits=(0,0))
pl.xticks(ind,('8 Sept','5 Oct','26 Oct'),fontsize=35)
pl.yticks(fontsize=35)
pl.legend(frameon=False,loc='upper right',fontsize=20)
pl.rcParams['axes.linewidth']=3
pl.xticks(rotation=45)
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()
